(use-translation _ "alterator-x11")

(on-prev (goto (global 'self)
		    'saved_depth (global "saved_depth")
		    'saved_resolution (global "saved_resolution")))
(define (on-update-error reason) '())

(define (apply-monitor)
  (list
    (woo-write "/xconf/data" 'monitor (monitors text))
    (goto (global 'self)
	       'saved_depth (global 'saved_depth)
	       'x11test (global `x11test)
	       'saved_resolution (global 'saved_resolution))))

(on-next (apply-monitor))

(define monitor->vendors (sort (woo-read-names "/monitors/vendors" (woo-list "/monitors/vendors")) string<?))
(define monitor->current_vendor (woo-get-option 
			      (woo-first-command (woo-read 
						  (string-append "/monitors/models/" (global 'selected_monitor)))) 
			      'vendor))
(define monitor->vendor_index (or (list-index (lambda (x) (string=? monitor->current_vendor x)) monitor->vendors) 0))
(define (getmodels name) 
    (sort 
	(woo-read-names 
	    (string-append "/monitors/vendors/" name) 
	    (woo-list (string-append "/monitors/vendors/" name))) 
    string<?)
)
(define default-models (getmodels (if (empty-string? monitor->current_vendor) (car monitor->vendors) monitor->current_vendor )))
(define monitor->model_index (or (list-index (lambda (x) (string=? (global 'selected_monitor) x)) default-models) 0))

(vbox spacing 2
  (groupbox (_"Choose your monitor:")
  (hbox spacing 0
  (vbox spacing 0
    (label (_"Vendor") font "-*-*-bold-*-*--*-*-*-*-*-*-*-*")
    (id 'vendors (listbox (items monitor->vendors)
				 current monitor->vendor_index
				   (on-select
				      (monitors items
					      (woo-catch
						(lambda()
						  (getmodels (vendors text)))
						on-update-error))
				 ) ))
  )
  (vbox spacing 0
    (label (_"Model") font "-*-*-bold-*-*--*-*-*-*-*-*-*-*")
    (id 'monitors (listbox (items default-models)
    				 current monitor->model_index
				 ))
  )
  ))
)
